; read nasmdoc.src for syntax differences nasm/masm !
bits 16

segment .text
        org  0  ; SYS skeleton based on bootrand.SYS 22.7.94 
		; (boot color and virus protection) by EA

; nasm produces plain, elf, win32, aout or obj on demand (-f option)
; to allow 386 code: .386
; to stop using 386 code: .8086
; to use 386 pm code: .386p
; check out the lines marked with FIXME !

next    dw -1,-1
attrib  dw 1000000000000100b    ; very "NUL" device
stra    dw strat	; *** preparation call - saves ES:BX
inr     dw intr		; *** execution call - uses data at saved ES:[BX]
nam     db 'EMMXXXX0'   ; our name - offset 10 into seg used by int 67
			; is also important for inst check!
	; FIXME: open EMMXXXX0, ioctl.0 that and ioctl.7 that should
	; FIXME: also return evidence that we are there and ready!
pb      dd 0		; does not matter now
used    db 0

; *** align 16	; not really important to align here
align 4

; --------------------------------------------------------------------
; --------------------------------------------------------------------

strat:  ; we could save the data or the pointer, I prefer the pointer.
        mov word  [cs:pb+2],es
        mov word  [cs:pb],bx
        retf

align 4

intr:   pushf
        push bx
        push es
        les bx,[cs:pb]
        mov byte  [es:bx+17h],0      ; no error
        and word  [es:bx+3],7FFDh    ; not busy / no error
        or word  [es:bx+3],1         ; ack status
        cmp byte  [es:bx+2],0        ; INIT ?
nnn:    jnz nix		; self-modifying code: inst only called once!
	jmp inst	; inst is at the end - will not stay resident
fail:	or word  [es:bx+3],8002h	; init fails
	and word  [es:bx+3],0fffeh	; no ack
	mov word  [es:bx+17h],1	; FIXME: return correct error code!
nix:    pop es
        pop bx
        popf
        retf

; --------------------------------------------------------------------

.386
align 4
	; our new but dummy int 67 handler
i67v:	jmp short i67v2	; this has to be a jmp short for chaining
	nop		; these are needed to allow patching the
	nop		; chain with a jmp far
	nop		; which is 3bytes longer than a jmp short
i67v2:	
	; FIXME: do something that wakes up the v86 host here - in
	; FIXME: case the host honors the int 67 chain at all:
	; FIXME: for now, I recommend going directly to the PM int 67
	; FIXME: and staying inside the v86 host if an int 67 occurs!
	int 67h		; *** recursion is the way to draw my own attention

	mov ah,80h	; this should never be reached, so our answer
			; to any request is "internal error"
	iret
i67old	dd 0		; FIXME: used only if we want to have uninstaller

; --------------------------------------------------------------------

setup8259:			; set up interrupt controllers
	mov al,11h		; master
	out 20h,al
	db 0ebh,0
	mov al,[cs:irq0num]
	out 21h,al
	db 0ebh,0
	mov al,4
	out 21h,al
	db 0ebh,0
	mov al,1
	out 21h,al
	db 0ebh,0

	mov al,11h		; slave
	out 20h,al
	db 0ebh,0
	mov al,[cs:irq8num]
	out 0a1h,al
	db 0ebh,0
	mov al,2
	out 0a1h,al
	db 0ebh,0
	mov al,1
	out 0a1h,al
	db 0ebh,0
	ret
	
; --------------------------------------------------------------------

align 4
	; our new int 15 handler
i15new:	cmp ah,88h	; query ext mem size?
	jnz i15chain
	mov eax,[cs:remainingkbyte]	; using eax is kind of undocumented
	iret
i15chain:
	; FIXME: add some wrapper here to keep function 89h (COPY) working
	nop
	db 0eah		; jmp far
i15old	dd 0		; old int 15 vector

; *** dat	ends		; end of 16bit fun

; --------------------------------------------------------------------
; --------------------------------------------------------------------
; --------------------------------------------------------------------

; *** pmseg	segment use32
	; this is our real 32bit code segment
; ***	org 0h

bits 32		; NASM: we are now in a use32 context, no new seg needed!
align 16	; so we can strip use16 areas better if we want that later
	; those are dummies and will be part of that tss later:
	db 'data starts here'
align 4
v86eax	dd 1
v86ebx	dd 2
v86ecx	dd 3
v86edx	dd 4
v86edi	dd 5
v86esi	dd 6
v86es	dd 8
v86ds	dd 16

vcpivec	dd vcpifunc	; this is a 48bit far pointer: first the offset,
	dw 24		; then the segment
vcpiv86	dw 0		; 0 if called from pm, 1 if called from v86
emsstat	dw 0		; the most recent ems status

emsseg	dw 0e000h	; the ems page frame segment
irq0num	dw 20h		; int that is used for irq0
irq8num	dw 28h		; int that is used for irq8
irqmask dw 0		; irq disable bits 8259

lowerbound	dd 100000h	; first byte of ext memory
upperbound	dd 100000h	; first unusable byte
remainingkbyte	dd 0h		; kilobytes int 15 should tell of
breakptr	dd 0h		; first byte of alloc'able ext memory
pagetabs	dd 0h		; where page tabs will be

; --------------------------------------------------------------------

	; FIXME: moving this above 10ffefh would be quite elegant...
	; FIXME: and it would add some security, if anybody wants to.
mycs	dw 0
myesp	dd 0ffch		; stack will be 1 page of high memory
myesp16	dd 0			; store esp of 16bit mode here

align 8
	; selectors are size16, base24, type, flags, basehi8
	; 16/32 only matters for cs, for ds the 40h bit means big and is
	; used for stack (expand down) segs and for the FPU address len...
	; big bit also selects ESP (strange if outside CS32 context) vs SP
	; if use32/big is 0, granularity should be 0, too (byte, not 4k)

	; *** GDT starts here
mynull	dw 0,    0, 0,     0	; 00 NULL selector is reserved
mycs32	dw 16,   0, 9a00h, 0c0h	; 08 CS32, granular, 64k
myds32	dw 16,   0, 9200h, 0c0h	; 10 DS-ESP, granular, 64k
myc016	dw -1,   0, 9a00h, 0	; 18 CS16, 64k, base remains at 0
;
mycs16	dw -1,   0, 9a00h, 0	; 20 CS16, 64k
myss32	dw 4095, 0, 9200h, 0	; 28 DS-SP, 4k, (our stack), high, pseudo32
mytabs	dw  3,   0, 9200h, 0c0h	; 30 DS-ESP, 12k, granular, holds IDT (2k) +
				; TSS (say 2k) + PGDIR (4k) +
				; INT handler code (4k), high
mypgts	dw  1,   0, 9200h, 0c0h	; 38 DS-ESP, granular, 4k*(1 per 4 MBy of
;				; managed total memory), high
mymeg1	dw 110h, 0, 9200h, 0c0h	; 40 DS-ESP, gr., 1M+64k (...110000h), base 0

myfoo	dw -1,   0, 9200h, 0cfh	; 48 FIXME: segs for other malloc data stuff

myALL	dw -1,   0, 9200h, 0cfh	; 50 FIXME: 4 gig gran. DS, for evil things!
myics32	dw  3,   0, 9a00h, 0c0h	; 58 CS32, 12k, granular: IDT entry points
mytxt16	dw 32767, 8000h, 920bh, 0 ; 60 DS-SP *16bit* b8000/len32k color text
;	; *** GDT ends here
	; TSS0 will be after IDT, normal v86 TSS16 right in the low seg,
	; TSS0 after IDT is dummy first: "leave" this to enter multitasking,
	; will be _our_ (we are the v86 monitor) TSS32 later...

myidt	dw 7ffh, 0, 0		; size16 (8 per int), base
				; IDT will take 2k of high memory (so we
				; waste 2k here - used as TSS0+TSS32)
	dw 0
mygdt	dw 67h, 0, 0		; size16, base24 (!), null8
	dw 0			; ?(sizehi8, basehi8)?
mynoidt	dw 0,0,0		; size 0, so any int will TRIPLE FAULT
	dw 0
myidt16	dw 03ffh, 0, 0		; standard value for real mode
	dw 0
mycr3	dd 0			; pointer to page (table) directory

vgacursor	dd 0

sexcept	dd sexc00, sexc01, sexc02, sexc03, sexc04, sexc05, sexc06, sexc07
	dd sexc08, sexc09, sexc0a, sexc0b, sexc0c, sexc0d, sexc0e, sexc0f
	dd sexc10, sexc11
;  ***	, sexc12, sexc13, sexc14, sexc15, sexc16, sexc17
;  ***	dd sexc18, sexc19, sexc1a, sexc1b, sexc1c, sexc1d, sexc1e, sexc1f
	; in the end, all but 2 (nmi), 8 (double fault), 9 (fpu seg...),
	; which are too serious, and
	; 0a..0e (and maybe 6, illegal opcode), which are special prot mode
	; are reflected back to the v86 task.
	; IRQ 0..f and of course int 67 (maybe 15) are also with special
	; handlers...
sexc00	db 'division by zero',0	; fault
sexc01	db 'single step',0	; trap or fault
sexc02	db 'NMI',0		; abort ---
sexc03	db 'breakpoint',0	; trap
sexc04	db 'IntO',0		; trap
sexc05	db 'bound',0		; trap
sexc06	db 'illegal opcode',0	; fault ***
sexc07	db 'FPU emulator',0	; fault
sexc08	db 'DOUBLE FAULT',0	; abort --- [C=with error code]
sexc09	db 'fpu segment',0	; abort ?
sexc0a	db 'INVALID TSS',0	; fault --- [C]
sexc0b	db 'missing segment',0	; fault --- (kill dos task only?)
sexc0c	db 'stack overflow',0	; fault --- [C]         ( -"- )
sexc0d	db 'GeNeRaL PrOtEcTiOn',0	; fault *** [C]
sexc0e	db 'page fault',0	; fault --- [C]         ( -"- )
sexc0f	db 'int 0f',0
sexc10	db 'fpu error',0	; fault
sexc11	db 'alignment check',0	; 
	; FIXME: add 12..1f if needed

scsip	db 'CS:IP --> ',0

	db 'use32 code next'
align 16	; to ease code/data separation if required later

; --------------------------------------------------------------------

strvga:	pushad		; show string at [cs:si] using direct graphic access
	pushf
	push es
	cld
	mov ax,10h	; myds32 (10h)
	mov es,ax
	mov eax,0b8000h	; video frame buffer for text
	add eax,[es:vgacursor]
	mov edi,eax
	mov ax,40h	; mymeg1 (40h): spans 1st meg
	mov es,ax
	mov ax,1e20h
	jmp short strv1
strvl:	mov al,[cs:si]
	or al,al
	jz strve
	inc si
strv1:	mov ah,1eh
	mov [es:edi],ax
	inc edi
	inc edi
	jmp short strvl
strve:	mov ax,1e20h
	mov [es:edi],ax
	inc edi
	inc edi
	sub edi,0b8000h	; as above
	mov ax,10h	; myds32 (10h)
	mov es,ax
	mov [es:vgacursor],edi
	pop es
	popf
	popad
	ret

numvga:	pushad		; print eax in hex, using direct graphic access
	pushf
	push es
	cld
	mov cl,28
	mov esi,eax
	mov ax,10h	; myds32 (10h)
	mov es,ax
	mov eax,[es:vgacursor]
	mov edi,0b8000h	; video frame buffer for text
	add edi,eax
	add eax,20	; skip ten chars next time
	cmp eax,4000	; end of screen?
	jb novadj
	xor eax,eax
novadj:	mov [es:vgacursor],eax
	mov ax,40h	; mymeg1 (40h): spans 1st meg
	mov es,ax
numvlp:	mov eax,esi
	shr eax,cl
	and al,0fh
	add al,30h	; '0'
	cmp al,3ah
	jb numv1
	add al,7 	; 'A' - ('9'+1), or 41h-3ah
numv1:	mov ah,1eh
	stosw		; al is char, ah is color
	sub cl,4
	test cl,0c0h
	jz numvlp
	pop es
	popf
	popad
	ret

; --------------------------------------------------------------------

generichandler:	; *** 8/2001 the generic IDT handler is called by:
		; *** pushl int_number ; jmp far mycs32(8):generichandler
	and eax,0ffh		; only look at vector number
	push ds
	push eax
	mov ax,10h		; myds32
	mov ds,ax
	xor eax,eax
	mov [ds:vgacursor],eax	; show every exception at the first line
	
		; FIXME: RealHardWork (TM) has to be done here
		; special treatment for IRQ, int 67h, and of course
		; for the INT/TRAP distinction, and various exceptions

	pop eax			; the least we can do is a bit of logging:
	push eax		; 0 eax -  SHOW number of exception
	call numvga		; ... maybe inc dword [ds:vgacursor] twice
	cmp eax,12h
	jnb nocomment
	mov esi,[cs:eax*4+sexcept]
	call strvga		; SHOW name of exception (even if reflected)
nocomment:
	pop eax
	push eax
	or al,al		; 0, div by zero, is a fault
	jz genericfault
	cmp al,2		; NMI is an abort
	jz genericabort
	and al,0feh
	cmp al,8		; 8 (double fault) and 9 (???) are aborts
	jz genericabort
	cmp al,6
	jb generictrap		; 1,3,4,5 and software ints are traps

genericfault:
	; *** a FAULT will restart the offending opcode (0,5,6,7,10..14,16)
	pop eax
	cmp al,10
	jb gfnocode
	cmp al,14
	ja gfnocode
gfcode:
		; FIXME: analyze the error code (for 10..14) somehow
		; FIXME: analyze cr2 linear page fault address as needed
		; FIXME: code is descriptor, lsb are LDT(4) IDT(2) IRQ(1)
gfnocode:
	xor eax,eax		; int num 0 as secret "this is a fault" sign
	push eax
	; FIXME: if we catch a fault, try to handle it, for example
	; FIXME: by invoking some 8086 simulation ! Most important: 0d (13)

generictrap:
;	mov eax,[ss:esp+4]	; 4 saved ds
;	call numvga		; SHOW valus
; ***	mov eax,[ss:esp+8]	; 8 flags (seems to be 0)
; ***	call numvga		; SHOW value
	mov esi,scsip
	call strvga		; SHOW description
	mov eax,[ss:esp+16]	; 16 cs
	call numvga		; SHOW value
	mov eax,[ss:esp+12]	; 12 ip
	call numvga		; SHOW value
	; other segs might be on stack, but ONLY if we got called from v86 ...

	pop eax
	or al,al
	jz wasafault
wasnofault:
	mov ecx,1000000	; wait a while... so user can realize fault/trap
fltlp:	db 0ebh, 0
	dec ecx
	jnz fltlp
			; *** FIXME: We might want to do something here ***
	pop ds
	pop eax		; we pushed this before we jumped to generichandler
	iret

wasafault:
	; FIXME: handle recoverable faults in a sensible way:
	; in most cases, simply bounce to v86 and wait what happens :-)
	; (bonus would be to notice if v86 cannot help itself and kill
	; the dos app then...)
	; FIXME: emulate some 6 (illegal opcode) and 0d (GENERAL PROTECTION)
	; FIXME: so we will be a nice v86 monitor! PS: 0a..0e have error codes
	; FIXME:    8 (double), 2 (nmi), 9 (fpu ...) may be ok for panic
	; FIXME: 10 (0ah).. 14 (0eh) are real protected mode things:
	; FIXME: 10 invalid tss - seems ok to panic
	; FIXME: 11 seg not present, 12 stack overflow, 14 page fault:
	; FIXME:    killing the dos app here could be a way to handle it
	mov eax,0b001f001h
	call numvga	; SHOW value of fool

; *****	db 0ebh, 0feh;	; *** FIXME: NOT YET HANDLED AT ALL ***

	jmp short wasnofault

genericabort:		; to be exact, 8 stores an error code - a constant 0
	mov eax,0deadbeefh
	call numvga	; SHOW value of beef
			; FIXME: even an abort deserves some more dumps
	mov ecx,3000000	; wait a 3mio while...
abrtlp:	db 0ebh, 0
	dec ecx
	jnz abrtlp
	mov al,0feh
	out 64h,al	; keyboard driven reset
	db 0ebh, 0feh	; well, we have to abort everything...


; --------------------------------------------------------------------

i67p:	; this is what REALLY gets called (ds=cs-alias)
	; (int XX inside v86 are virtualized)
	; to write v86 regs, use the v86 tss!
	; to use v86 segs, use v86 tss and translation
	cmp ah,0deh
	jnz i67ems
i67vcpi:
	mov word [ds:vcpiv86],1	; we were called from v86 mode
	call far [ds:vcpivec]
	mov word [ds:vcpiv86],0	; being called from PM is default
	jmp short i67statusvcpi

i67ems:	; this is the actual LIM EMS thing
	cmp ah,40h
	jb i67unsupp
	ja ems1
emsquery:
	mov ah,	[ds:emsstat]	; ask for last status (or is it always 0/80?)
	jmp short i67status
ems1:	cmp ah,42h
	jz ecountpages
	ja ems2
egetframe:
	mov bx,[ds:emsseg]	; return the segment of that page frame
	mov [ds:v86ebx],bx
	jmp short i67ok
ems2:	cmp ah,44h
	jz emappage		; map handle dx page bx to frame al
	jb eallocmem		; alloc bx 16k pages, return handle dx
	cmp ah,46h
	ja ems3
	jb efreemem		; release handle dx and memory
egetversion:
	mov al,032h		; return version 3.2
	jmp short i67ok
ems3:	cmp al,48h
	jz erestoremapping	; restore mapping for handle dx
	jb esavemapping		; save mapping for handle dx	
	cmp al,4bh
	jz ecounthandles	; get number of handles to bx
	jb i67unsupp		; 49 and 4a are undocumented features
	cmp al,4dh
	jz egetpagelist		; fill array [es:di] with handle,size
				; (words) pairs - return number of
				; returned entries in bx
	jb ereadsize		; return size of handle dx in bx
	cmp al,4eh
	ja i67unsupp		; the rest is ems 4.0 so we skip that now!
egetmappingdetails:		; this is intended for O/S use only
	jmp short i67unsupp	; or return 8f...
				; there are in fact complex subfuncs 0..3

i67ok:	; we return 0,80,81,83,84,85,86,87,88,89,8a,8b,8c,8d,8e,8f,a3
	; but only few make sense... e.g. 81 is hardware error
	; 0,80,81,84 work for most cases :-)
	; vcpi has no error codes but only zero/nonzero return value
	xor eax,eax	; success
	jmp short i67status
i67unsupp:
	mov ah,84h	; undefined function - 8fh: ... subfunction
	jmp short i67status
i67fail:
	mov ah,80h	; internal error
i67status:		; save status for later and return it in ah
	mov byte [ds:emsstat],ah
i67statusvcpi:		; do no save last status if vcpi
	mov byte [ds:v86eax+1],ah
        retf		; return to v86 host

; --------------------------------------------------------------------

ecountpages:
emappage:
eallocmem:
efreemem:
esavemapping:
erestoremapping:
ecounthandles:
egetpagelist:
ereadsize:
	; FIXME: implement those ems functions
	jmp short i67fail
; --------------------------------------------------------------------

vcpifunc:	; this is our vcpi handler
	cmp ah,0deh
	jnz near vcpifail
	cmp al,0ch
	ja near vcpifail
	jb vcpi1
	cmp word [ds:vcpiv86],0
	jz near vswitchtov86	; if we were called from PM, switch to v86
	jmp vswitchtopm	; if called from v86, switch to PM
			; FIXME: those switches may be complicated
vcpi1:
	cmp al,1
	jz near vnewclient	; init vcpi for new client (kind of useless from PM)
				; FIXME: implement this complex thing!
	ja vcpi2
vcpivers:
	mov bx,005ah		; Version 0.90
	jmp short vcpiok
vcpi2:	cmp al,3
	jz near vcountfree	; get number of free 4k pages to edx
	ja vcpi3
vcpimax:
	mov edx,[ds:upperbound]
	sub edx,4096	; get phys addr of highest page to edx
	jmp short vcpiok
vcpi3:	cmp al,5
	jz near vfreepage	; free 4k page at edx
	jb near vcpialloc	; alloc a 4k page and return phys addr in edx
	cmp word [ds:vcpiv86],0
	jz vcpifail	; func 6..b are not allowed from PM (and not needed)
			; nice: we can assume cpl 0 from now on :-)
	cmp al,7
	jb vreadmapping	; read phys addr of page no cx to edx
	ja vcpi4
vreadcr0:
	mov ebx,cr0	; priv needed! - read cr0 to ebx
	jmp short vcpiok
vcpi4:	cmp al,9
	jz vwritedr	; write debug regs from buffer [es:di]
	jb vreaddr	; read debug regs to buffer [es:di]
	cmp al,0bh
	jz vnotify8259	; 
	jnb vcpifail	; should never happen
vread8259:		; read setup of 8259 to bx, cx
	mov bx,[ds:irq0num]	; number of int used for irq 0
	mov cx,[ds:irq8num]	; number of int used for irq 8
	jmp short vcpiok
	
vcpifail:
	mov ah,80h
vcpiretval:
	cmp word [ds:vcpiv86],0
	jz someretf	; if we were called from PM, simply return
	mov [ds:v86eax+1],ah
someretf:
	retf

vcpiok:	xor ah,ah
	cmp word [ds:vcpiv86],0
	jz someretf	; if we were called from PM, simply return
	mov [ds:v86eax+1],ah
	mov [ds:v86ebx+1],ebx
	mov [ds:v86ecx+1],cx
	mov [ds:v86edx+1],edx
	mov [ds:v86edi+1],di
	retf

; --------------------------------------------------------------------

vreaddr:	; reading...
vwritedr:	; ...and writing debug regs
	; FIXME: implement this - take care, you need to convert
	; FIXME: the segments from the v86 tss
	jmp short vcpifail

vnotify8259:	; tell vcpi host that 8259 was reprogrammed
	; FIXME: we should panic here or freemm386 should adjust
	; FIXME: the idt ... but then it may still happen that
	; FIXME: irqs and exceptions share the same ints and
	; FIXME: we are not prepared for that
	; bx, cx are given as irq0 and irq8 int numbers
	jmp short vcpifail

vswitchtopm:
vswitchtov86:
vnewclient:
	; FIXME: well, THOSE are really important but complex
	; vnewclient has 3 gdt entries: we return our cs descriptor
	; first, then 2 arbitrary descriptors we want the client to
	; provide everytime it calls us (so we have to setup ds as (e.g.)
	; cs+8 in our handler - we may not use constants for segments ! )
	jmp short vcpifail

vfreepage:
vcpialloc:
vcountfree:
vreadmapping:
	; FIXME: the actual PAGE ALLOCATION should be right here!
	jmp short vcpifail


bits 16		; NASM: use16 context again
align 16	; easier for copying stuff around later

; *** pmseg	ends

; --------------------------------------------------------------------
; --------------------------------------------------------------------
; --------------------------------------------------------------------

; *** dat2	segment use16
	; this seg is for 16bit init stuff and will get trashed
	; everything past this point will not stay resident:

	db 'non-tsr code starts here '

align 4
ente    db 'freemm v0.002 loading'

; --------------------------------------------------------------------

align 16	; so we can separate segs later
.8086
	; assume no special cpu for now
	; nice verbose strings added 8/2001
huhu	db 'Treiber: LIM EMS 3.x und VCPI 0.9 - Eric Auer 2001',13,10,0

sok386	db 0,		'386 Prozessor gefunden',13,10,0
sno386	db 'Kein 386 oder besserer Prozessor gefunden',13,10,0
soka20	db 0,		'A20 freigeschaltet',13,10,0
snoa20	db 'A20 noch nicht freigegeben',13,10,0
swarnvd db 'VDISK Angaben inkonsistent',13,10,0
snomem	db 'Nicht genug Speicher frei',13,10,0
sokmem	db 0,		'Genug freien Speicher gefunden',13,10,0
	; FIXME: add verbosity to init stuff inside protected mode, too

sallok	db 13,10,'Treiber ist jetzt installiert',13,10,0

numexp	db ' = ',0
scrlf	db 13,10,0

infeof	db 'end of resident driver pointer',0	; [es:bx+0eh]
inflow	db 'lowerbound (of ems memory)    ',0	; lowerbound
infhi	db 'upperbound (of ems memory)    ',0	; upperbound
infrem	db 'remaining int 15 mem (kbytes) ',0	; remainingkbyte
infmem	db 'memory used for lim ems / vcpi',0	; upperbound-lowerbound
infi15	db 'int 15h new',0			; [es:15h+15h+15h+15h]
info15	db 'int 15h old',0			; i15old
infi67	db 'int 67h new',0			; [es:67h+67h+67h+67h]
info67	db 'int 67h old',0			; i67old
infbrk	db 'free memory starts at break',0	; breakptr
infgdt	db       'GDT pointer structure:  ',0	; mygdt
infidt	db 13,10,'IDT pointer structure:  ',0	; myidt
infcr3	db 13,10,'CR3 (page dir pointer): ',0	; mycr3
infpsz	db 'bytes of page tables:   ',0		; mypgts, first 2 bytes
smygdt	db 'the GDT: null, cs32, ds32, c016, cs16, '
	db 'ss32, tabs, pgts, meg1, foo, ALL, ics32',13,10,0	; mynull etc
smygdtx	db ', ',0				; a comma and a space :-)
sgdteof	db '*EOF*',13,10,0			; indicate EOF gdt

; --------------------------------------------------------------------

strtty:	pusha		; print a zero terminated string
	pushf
	push ds
	mov ax,cs
	mov ds,ax
sttlop:	mov bx,7
	mov ah,0eh
	lodsb
	or al,al
	jz sttend
	int 10h
	jmp short sttlop
sttend:	pop ds
	popf
	popa
	ret

numtty:	pusha		; print eax in hex
	pushf
	mov cl,28
	mov edi,eax
numlop:	mov eax,edi
	shr eax,cl
	and al,0fh
	add al,30h	; '0'
	cmp al,3ah
	jb num1
	add al,7 	; 'A' - ('9'+1), or 41h-3ah
num1:	mov ah,0eh
	mov bx,7
	int 10h
	sub cl,4
	test cl,0c0h
	jz numlop
	popf
	popa
	ret

numinf:	call strtty	; show a string explaining number ([cs:si])
	mov si,numexp
	call strtty	; show bla
	call numtty	; show number (eax) in hex
	mov si,scrlf	; new line
	call strtty
	ret

; --------------------------------------------------------------------

gofail:	popf				; clean up stack, then fail:
	pop ax
	push si
	mov si,sno386
	call strtty			; SAY 386 not found
	pop si
	sti
	jmp fail			; we could not bootstrap emm :-(

inst:   ; assume es and bx are sane - es/bx/f are already on stack
        mov word  [es:bx+10h],cs
        mov word  [es:bx+0eh],ente    ; *** end of resident data

	push si
	mov si,huhu
	call strtty			; SAY hello
	pop si

	cli
	; we need at least a 386 cpu
	push ax
	pushf	; save flags
	xor ax,ax
	push ax
	popf		; try to clear all bits
	pushf
	pop ax
	and ax,0f000h
	cmp ax,0f000h
	jz near fail	; 4 msb stuck to 1: 808x or 80186
	mov ax,0f000h
	push ax
	popf		; try to set 4 msb
	pushf
	pop ax
	test ax,0f000h
	jz gofail	; 4 msb stuck to 0: 80286
	popf	; restore flags
	pop ax
.386
	; now we are allowed to use 386 code :-)
	; and we have to do lots of init stuff :-(

	push eax
	push si
	mov si,sok386
	call strtty			; SAY 386 found
	mov si,infeof
	mov eax,[es:bx+0eh]
	call numinf			; SAY eof pointer
	pop si
	pop eax
	
	push es
	push ds
	pushad		; save all regs

; --------------------------------------------------------------------

checka20:
	; figure out if a20 is enabled if not, there are two options:
	; a) ask himem to enable the a20 or b) do it yourself. I prefer b).
	mov ax,0ffffh
	mov es,ax
	xor ax,ax
	mov ds,ax
	cli
	mov bx,[es:10h]	; 100000h or 0h depending on a20 status
	cmp bx,[ds:0]
	jnz a20ok
	inc word  [es:10h]
	inc bx
	cmp bx,[ds:0]	; if it is still the same, a20 is disabled
	jnz a20ok
a20off:	dec word  [es:10h]

a20enable:	; taken from linux 0.01 boot sector
	; FIXME: warn weirdos that we are giving up PC-XT compatibility ;)
	pushf
	sti
	call wait8042
	mov al,1
	out 64h,al
	call wait8042
	mov al,0dfh
	out 60h,al
	call wait8042
	popf

	push si
	mov si,snoa20
	call strtty			; SAY A20 not yet enabled
	pop si

	jmp short checka20	; just hang on until it works :-S

wait8042:		; wait until 8042 accepts new data
	in al,80h	; dummy read to waste time
	in al,64h
	test al,2
	jnz wait8042	; wait endless for the 8042 to be ready
	ret

a20ok:			; without a20 enabled, everything else is useless

	push si
	mov si,soka20
	call strtty			; SAY A20 enabled
	pop si

; --------------------------------------------------------------------

	; now we check out how much RAM is free for us
	xor eax,eax
	mov ah,88h
	int 15h		; get amount of ext memory
	shl eax,10	; returned value has unit kbyte
	cmp eax,65536	; require (say) 64k
	jb near notenuf	; not enough free memory
	mov ebx,100000h	; 1 meg
	add eax,ebx
	mov [cs:upperbound],eax	; first byte we may NOT use

	mov [cs:lowerbound],ebx	; only use ext. memory
				; now check for lower bound:
	xor ax,ax
	mov es,ax
	mov es,[es:19h+19h+19h+19h+2]	; seg of int 19 handler
	cmp dword  [es:12h],'VDIS'
	jnz vdisk2
	cmp word  [es:16h],'K '
	jnz vdisk2	; seg-of-int19[12] = "VDISK " ?
	mov eax,dword  [es:2ch]
	and eax,0ffffffh	; 24bit pointer to end of vdisk
	cmp eax,[cs:lowerbound]
	jb warnvdisk1	; should not happen
	cmp eax,[cs:upperbound]
	jae warnvdisk1
	mov [cs:lowerbound],eax	; new lower bound
warnvdisk1:

	push si
	mov si,swarnvd
	call strtty			; SAY warn about vdisk inconsistency
	pop si

vdisk2:
	mov ax,0ffffh
	mov es,ax
	cmp dword  [es:13h],'VDIS'	; this is lin addr 100003
	jnz vdisk3
	cmp byte  [es:17h],'K'
	jnz vdisk3
	xor eax,eax
	mov ax,word  [es:2eh]	; this is lin addr 10001e
	shl eax,10	; value has unit kbyte
	cmp eax,[cs:lowerbound]
	jb warnvdisk2	; should not happen, but see below
	cmp eax,[cs:upperbound]
	jae warnvdisk2
	; FIXME: warn if cmp eax,cs:lowerbound is non-zero
	; FIXME: -and- lowerbound is not still 100000h
	mov [cs:lowerbound],eax	; new lower bound
warnvdisk2:

	push si
	mov si,swarnvd
	call strtty			; SAY warn about vdisk inconsistency
	pop si

vdisk3:
	; now we know upper and lower bound of ext mem
	mov eax,[cs:upperbound]
	sub eax,[cs:lowerbound]
	cmp eax,65536	; do not support tiny ext memory
	ja vdisk4
notenuf:	; fail, not enough ext memory free
	popad	; restore all regs
	pop ds
	pop es
        sti

	push si
	mov si,snomem
	call strtty			; SAY not enough memory
	pop si

	call showmembounds		; *** tell about memory

	jmp fail

showmembounds:
	push eax
	push si
	mov eax,[cs:upperbound]
	sub eax,[cs:lowerbound]
	mov si,infmem
	call numinf			; SAY how much memory for us
	mov eax,[cs:remainingkbyte]
	mov si,infrem
	call numinf			; SAY how much memory left to int 15h
	mov eax,[cs:lowerbound]
	mov si,inflow
	call numinf			; SAY lower bound
	mov eax,[cs:upperbound]
	mov si,infhi
	call numinf			; SAY higher bound
	pop si
	pop eax
	ret

vdisk4:

	push si
	mov si,sokmem
	call strtty			; SAY enough memory
	pop si
	; FIXME: add some self limitation here so we can leave some
	; FIXME: ext memory to other memory managers!
	; for now, we simply say "no more ext memory available but hma"
	; (even if hma was not used at all before, we will not touch it)
	mov dword  [cs:remainingkbyte],64

	call showmembounds		; *** tell about memory


; --------------------------------------------------------------------

downalloc:
	; alloc memory using int 15
	xor ax,ax
	mov es,ax
	mov eax,[es:15h+15h+15h+15h]
	mov [cs:i15old],eax	; save old handler
	xor eax,eax
	mov ax,cs	; cs !
	shl eax,16
	mov ax,i15new	; our new handler
	mov [es:15h+15h+15h+15h],eax	; atomic write, no cli needed

	mov eax,[es:67h+67h+67h+67h]
	mov [cs:i67old],eax	; save old handler
	xor eax,eax
	mov ax,cs	; cs !
	shl eax,16
	mov ax,i67v	; our new handler - in fact only a dummy. see above!
	mov [es:67h+67h+67h+67h],eax	; atomic write, no cli needed

	push si
	mov eax,[cs:i15old]
	mov si,info15
	call numinf		; SAY old int 15h pointer
	mov eax,[es:15h+15h+15h+15h]
	mov si,infi67
	call numinf		; SAY new int 67h pointer
	mov eax,[cs:i67old]
	mov si,info67
	call numinf		; SAY old int 67h pointer
	mov eax,[es:67h+67h+67h+67h]
	mov si,infi67
	call numinf		; SAY new int 67h pointer
	pop si
	jmp short mkgdt
; --------------------------------------------------------------------

togdt:	push eax
	push ebx		; set base pointer and go on to next selector
	inc di
	inc di			; skip size
	rol eax,8		; highest byte will become lowest
	mov bl,al
	mov al,[cs:di+3]	; read flags
	ror eax,8		; restore standard order
	mov [cs:di],eax		; write base24, write back flags
	mov al,bl		; PS: di+4 contains additional flags and
				; possible 4 more BITS of size
	mov [cs:di+5],al	; write high byte of base
	add di,6		; go on to next selector
	pop ebx
	pop eax			; (a bit more rolling -> no eax on stack)
	ret

; --------------------------------------------------------------------

	; 8/2001 - first part of v86 stuff is to set up various struct...

	; assuming enough memory here, because we have checked before
	; actually, we should check for weird cases such as a very high
	; upperbound (which will take us upperbound/1k of tables to manage!)
mkgdt:	xor eax,eax
	mov ax,cs
	mov [cs:mycs],ax
	shl eax,4
	mov ebx,eax		; our seg in terms of linear address
	mov edi,mynull		; gdt starts here (offset 16)
	add eax,edi		; gdt starts here (linear)
	mov [cs:mygdt+2],eax	; set up gdt pointer
	mov ax,herewego		; needed to switch to PROTECTED
	mov [cs:hwgptr],ax	; as we START in cs16, offset is 16 bit!

	mov eax,ebx		; our (low) seg in linear terms
	add di,8		; (null seg does not really need this)
	call togdt		; 08 mycs32
	call togdt		; 10 myds32
	add di,8		; 18 myc016 not changed (first 64k)
	call togdt		; 20 mycs16

	mov eax,[cs:lowerbound]	; set up high data structures next
	mov ebx,4096		; 4k is a popular constant...
	add eax,ebx
	dec eax
	and eax, 0fffff000h	; next 4k boundary

	call togdt		; 28 myss32 stack segment (4k)
	add eax,ebx		; +4k

	mov [cs:myidt+2],eax	; *** store pointer to real IDT for IDTR !!!

	push eax
	add eax,ebx		; there we have the PAGE DIRECTORY
	mov cr3,eax		; SET cr3 (will only take effect if PG is 1)
	mov [cs:mycr3],eax	; used for reload to flush TLB ...
	pop eax
	push eax
	call togdt		; 30 mytabs IDT (2k), TSS (2k?), PGDIR (4k),
	pop eax			;    IDT handler code (4k)
	push di
	mov di,myics32
	call togdt		; 58 myics32: IDT handler CS (12k)
	pop di			; 38
	add eax,ebx
	add eax,ebx
	add eax,ebx		; +12k
	push eax
	mov eax,[cs:upperbound]
	add eax,ebx
	dec eax			; round this
	shr eax,22		; (12 for granular + 10 for pgtab sizes)
	mov [cs:di],ax		; set PGTAB size
	shl eax,12		; PGTAB size in bytes
	mov ebx,eax		; ebx redefined ...
	pop eax
	mov [cs:pagetabs],eax	; store where pagetabs will be
	call togdt		; 38 mypgts one PGTAB per 4 megs of RAM
	add eax,ebx		; + PGTAB size
	add di,8		; 40 mymeg1 unchanged: first 1 meg + a20
	call togdt		; 48 FIXME: seg for malloc tab
	; ... maybe add more	; 50 is the "myALL" selector for setup now!
	mov [cs:breakptr],eax	; lowest available high memory

	mov si,infbrk
	call numinf		; SAY where our break pointer is
	mov si,infgdt
	call strtty		; SAY we are gonna show gdtr
	mov eax,[cs:mygdt+4]
	call numtty		; SAY ...
	mov eax,[cs:mygdt]
	call numtty		; SAY ... gdtr contents (8 by)
	mov si,infidt
	call strtty		; SAY we are gonna show idtr
	xor eax,eax
	mov ax,[cs:myidt+4]
	call numtty		; SAY ...
	mov eax,[cs:myidt]
	call numtty		; SAY ... idtr contents (6 by)
	mov si,infcr3
	mov eax,[cs:mycr3]
	call numinf		; SAY where cr3 will point to
	mov si,infpsz
	xor eax,eax
	mov ax,[cs:mypgts]	; number of page tables...
	shl eax,12		; 2+10
	call numinf		; SAY how big page tables will be
	mov si,smygdt
	call strtty		; SAY gdt will be dumped
	mov cx, [cs:mygdt]	; number of gdt entries to be dumped
	inc cx			; limit -> size "conversion" :)
	shr cx,3		; 8 byte per entry
	mov di,mynull		; let the fun begin
sgdtl:	mov eax,[cs:di+4]
	call numtty		; SAY high 32 bits
	mov eax,[cs:di]
	call numtty		; SAY low 32 bits
	mov si,smygdtx
	call strtty		; SAY ", "
	add di,8
	test cx,3
	jnz sgncr
	mov si,scrlf
	call strtty		; SAY start a new line
sgncr:	dec cx
	jnz sgdtl		; loop ...
	mov si,sgdteof
	call strtty		; SAY we are done

; --------------------------------------------------------------------

	mov ax,pmfar2		; self-modifying code to adjust this jump
	mov [cs:pmfar1],ax
	mov al,80h		; DISABLE NMI
	out 70h, al
	cli
	in al,21h
	mov ah,al
	in al,0a1h
	mov [cs:irqmask],ax	; store interrupt mask
	db 0ebh,0
	mov al,0ffh
	out 21h,al
	out 0a1h,al		; 8259 disable interrupts

	call setup8259		; REVECTOR IRQs by programming 8259

	cli			; DISABLE INTERRUPTS
	mov [cs:myesp16],esp	; store this...

	xor esp,esp		; disable stack
	xor eax,eax
	mov ds,ax		; zero out all segs
	mov es,ax
	mov fs,ax
	mov gs,ax
	mov ss,ax
	lgdt [cs:mygdt]		; load that GDTR !
	lidt [cs:mynoidt]	; load that IDTR, but only with DUMMY !
				; (will have 8086 semantics until PE is 1)
				; (but is empty - any int will TRIPLE FAULT)
	mov eax,cr0
; *** align 16			; as you never know...
	or al,1			; set PE to 1, enable PROTECTED MODE
				; (but do not enable PAGING yet)
	mov cr0,eax
	db 0eah			; jump far to reload CS
pmfar1:	dw 0
	dw 20h			; mycs16 (20h)
pmfar2:
				; seg contents stay as is until changed
	nop
	nop
	mov ax,10h		; myds32 (10h)
	mov ds,ax
	mov es,ax
	mov fs,ax
	mov gs,ax
	mov ax,28h		; myss32 (28h)
	mov ss,ax
	mov esp,0ffch		; 4k-4by

; --------------------------------------------------------------------

	mov ax,30h		; mytabs (30h): IDT 2k, TSS0/32 2k, PGDIR 4k
				; ... and handler code 4k

	mov es,ax		; create IDT and handlers in one loop
	cld
	mov di,8192		; code offset
	xor bx,bx		; idt offset
	xor cx,cx		; vector number

	; handler looks like: int gate, own stack, (pushb: 6a pushl/w: 68)
	; push eax; mov al,number; jump far to generic handler far above...

idtlop:	mov ax,0b050h		; push eax (50h) , mov al (0b0h) , ...
	mov dx,di
	mov [es:di],ax
	inc di
	inc di
	mov al,cl
	mov ah,0eah		; jmp far ...
	inc cx			; next time: next vector
	mov [es:di],ax
	inc di
	inc di
	mov eax,generichandler	; in myics32, so we use 16:32 pointers
	mov [es:di],eax		; jump destination offset
	inc di
	inc di
	inc di
	inc di
	mov ax,8h		; mycs32
	mov [es:di],ax		; jump destination mycs32
	inc di
	inc di
	mov ax,dx		; restore code offset...
	mov [es:bx],ax		; code offset for handler low 16
	inc bx
	inc bx
	mov ax,58h		; myics32
	mov [es:bx],ax		; code segment for handler is myics32 !!!
	inc bx
	inc bx
	mov ax,8e00h		; present, dpl 00, 0, 32bit, int=110, 00000000
	mov [es:bx],ax		; gate type/flags and reserved
	inc bx
	inc bx
	xor ax,ax
	mov [es:bx],ax		; code offset for handler high 16
	inc bx
	inc bx
	or ch,ch		; all handlers done?
	jz idtlop		; JZ !!

	mov di,4096		; now set up page (table) directory
	mov eax,[cs:pagetabs]	; pagetabs will be there and higher
	mov cx,[cs:mypgts]	; how many pagetabs are there?
pgtnm:	and eax,0fffff000h	; clear, just in case...
	or ax,067h		; usr xxx, (X), (Y), dirty, accessed, (pcd),
				; (pwt), user-usable, writeable, present
				; (pcd=do not cache / pwt = write through)
	stosd
	add eax,1000h		; 4k later...
	dec cx
	jnz pgtnm

	mov ax,38h		; mypgts (38h) - the seg for the page tables
	mov es,ax
	mov eax,00000007h	; fill all those tables...
	xor edi,edi
	xor ecx,ecx
	mov cx,[cs:mypgts]	; how many entries?
	shl ecx,10		; 1024 per table
				; tables will take up to 1/1024 of RAM
	; needs 32bit addr for more than 64 megs of RAM
pgtnm2:	mov [es:edi],eax
	inc edi
	inc edi
	inc edi
	inc edi
	add eax,1000h		; 4k later...
	dec ecx			; using ecx is not exactly useful yet ...
	jnz pgtnm2

	mov eax,cr0		; cr3 has to be set before PG - ok, done so.
	mov ebx,[cs:mycr3]	; prepare for later reload

	or eax,80000001h	; Enable PG (PAGING) *and* PE (PROTECTED)

align 16
	mov cr0,eax
	db 0eah			; jmp far to update cs
hwgptr:	dw 0			; 16bit, as we start in 16bit segment...
	dw 20h			; mycs16 (20h) (mycs32 is 8h, used in v86mon +
				; int 67 handler - only resident part, that is)
	dw 0			; padding
align 16
herewego:

	mov eax,ebx
	mov cr3,eax		; reload cr3 to flush TLB

	lidt [ds:myidt]		; load that IDTR with FINAL IDT value!
	

	; now we use mytabs (30h) to access IDT (2k), TSS0 (2k), PGDIR (4k),
	; mypgts (38h) to access PGTABs (n*4k), mymeg1 (40h) to acc. 1st meg,
	; my??? (48h) to access malloc tables and myics32 (58h) as handler cs
	; and myALL (50h) to do evil things if we forgot something :-)
	; not to forget myc016 (18h), which is the 1st 64k. And mynull (0).

; FIXME: Have to set up INT handlers, 67h+except+irq extra! (far above in cs32)
; FIXME: later manage PGTABS, set up our own TSS16 (inside this seg, above),
; FIXME: then point current TSS to TSS0 (high) which will become TSS32...
; FIXME: go for MULTITASKED VIRTUAL 8086 MODE (v86 -> we need lots of handlers)


; ************************************
selfdestruct:
	mov ecx,1000000		; 1mio
hummm:	dec ecx
	jnz hummm

	mov al,0		; ENABLE NMI
	out 70h,al
	mov ax,[cs:irqmask]	; restore old 8259 masking
	out 0a1h,al
	mov al,ah
	and al,0f8h		; enable timer and keyboard and chaining
	out 21h,al
	sti			; ENABLE INTERRUPTS

	int 5h			; annoy monitor a bit, do testing
	int 20h
	int 0dh

	mov ecx,1000000		; 1mio
humm2:	dec ecx
;	push eax		; evil grin...
	jnz humm2

	mov al,0feh		; REBOOT VIA KEYBOARD
;	out 64h,al		; GO FOR CRASH =8-)
	jmp short hummm

; --------------------------------------------------------------------

	; THE REST IS STILL AN EXERCISE FOR THE READER !!!

	; next: set up the v86 host, jump to protected mode,
	; alloc the necessary tables (outside the v86 accessible
	; area if possible!), set up exception and irq handlers
	; (reprogram the 8259 unless irq0num=8 and irq8num=70h !)
	; and finally return "control" to DOS (in a v86 task)
	; FIXME: do not forget to read irq0num and irq8num as sources
	; FIXME: of the 8259/irq setup (compile time option) !

	; we will reprogram the 8259 PIC (interrupt/irq controller)
	; to map the IRQs to int 20..2f - this could confuse some
	; older VCPI apps, so maybe we should allow exceptions to
	; be the same ints as irqs? exceptions are 0..1f, by the way.

	; handlers for int 30..ff are not needed, as int (cd xx) is
	; emulated anyhow. HINT: using some pentium gimmicks would
	; allow to do int (cd xx) and flag access stuff in hardware
	; and gain speed, but only on pentium or above - AND in
	; addition, I dont know how to use those anyhow :-S
	; at least giving the v86 task iopl 3 (so it may do arbitrary
	; I/O port accesses) is a simple way to gain speed and simplicity.

; --------------------------------------------------------------------

	; the v86 host will emulate int (cd xx) and similar calls,
	; flag writing (popf, iret), and react in a sensible way to
	; priviledged instruction requests.

	; the v86 also catches all exceptions and irqs and acts on
	; them (like displaying debugging info, redirecting irqs to
	; their old dos handlers in the v86 task, redirecting int 67
	; to the main ems/vcpi handler) !

	; the vcpi interface has to be available from PM, too, so
	; we need a wrapper for that and cannot assume we return to
	; the v86 task after vcpi - we only do this if called from v86.

; --------------------------------------------------------------------

	; tables we need: gdt, idt, page tables for the v86 task and
	; the ram we need ourself (not more!), a bitstring for all
	; available physical ram pages to know which are free.
	; FIXME: no longer true. see "BETTER" below for the bitstring.

	; for 1m+64k+X we need 1 page table (4k) and 1 page table dir (4k).
	; the idt will be at most 256x8by = 2k, but 48x8by should be ok.
	; the gdt will be kind of tiny. and dont forget the v86 and pm tss
	; (104+ by each) and the pm stack (!). "X" will be server code/data
	; so it is out of reach of the v86 task and does not waste DOS mem.
	; thats why we need to enable PM, then do some table setup and THEN
	; we may enable paging (because page tables are above 1 meg) !

; --------------------------------------------------------------------

	; last but not least, we need to store handle info (for ems,
	; not for vcpi): handle numbers are word values, handle sizes too,
	; and of course the list of used physical pages for each handle.
	; each of at least 4 16k blocks (minimum is 64k page frame)
	; has (zero or) one 16k "page" of one handle mapped.
	; list should be stored with handle, even if only one mapping per
	; block is possible at each time.
	; FIXME: only save/restore context of "pages" belonging to the
	; FIXME: requested handle, not all 4 or more "page frames".
	; FIXME: so we need some value saying "dont ask this handle"

	; the 4x2words "mapping context" may be stored for each handle ->
	; 2?x16by mapping status per handle - kind of wasted space sometimes?
	; IDEA: use only set of 1 mapping status and store other mapping
	; info in the global mapping list (the one for the real "page frame")
	; btw: only offering at most 256 handles is ok -> save space...

	; BETTER handle/page lists: alloc 2by (the handle no) per 16k or
	; physical page for ALL ext mem on init instead of using bitstrings
	; and lists of pages for each handle.
	; (careful: vcpi only needs bits and has 4k allocation unit)
	; this will slow down alloc and free because we need to walk the
	; array to get/change some info, but it only needs 1/2024 
	; (or less if we use 16k pages) of ext memory regardless of
	; the number of used handles :-)

; --------------------------------------------------------------------

	mov ax,[cs:irqmask]		; restore old 8259 masking
	out 0a1h,al
	mov al,ah
	out 21h,al

	push si
	mov si,sallok
	call strtty			; SAY setup done
	pop si

	popad	; restore all regs
	pop ds
	pop es
        sti
        mov bx,nnn			; Patch INIT
        mov byte  [cs:bx],0ebh	; JMP unconditional short
        jmp nix		; now we leave the non-resident part forever


segment .bss align=16
dummy_tss	resb 104h	; ***
	; will become overwritten by a pseudo-tss (status of real mode)

; *** 	dat2	ends
; ***	dat	ends
end
